<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright Â© 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: Facebook Connect Panel v1.0
| Filename: register.php
| Author: Ankur Thakur
| Version: 1.0
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";

if (file_exists(INFUSIONS."facebook_connect_panel/locale/".$settings['locale'].".php")) {
   include INFUSIONS."facebook_connect_panel/locale/".$settings['locale'].".php";
     } else {
   include INFUSIONS."facebook_connect_panel/locale/English.php"; 
}

//session_start();

opentable($locale['panel_title']);

if (isset($_SESSION['fbc_status']) && ($_SESSION['fbc_status'] == 1) && ($_SESSION['fbc_userid'] != 0) && ($_SESSION['fbc_userid'] != ""))
{

if (iMEMBER)
{
	$error = 0;

	$filename = "";
	// php_openssl Extension required to Read Headers from a HTTPS connection
	if (extension_loaded('openssl'))
	{
		// Uploading Facebook Avatar
		$url = "https://graph.facebook.com/".$_SESSION['fbc_userid']."/picture?type=normal";
		$location = get_headers($url, 1);
		if (array_key_exists('Location', $location))
		{
			$content = file_get_contents($location['Location']);
			if ($content)
			{
				$filename = rand().".jpg";
				while (file_exists(IMAGES."avatars/".$filename))
				{
					$filename = rand().".jpg";
				}
				$file = fopen(IMAGES."avatars/".$filename, 'w');
				fwrite($file, $content);
				fclose($file);
				// Delete Old Avatar
				@unlink(IMAGES."avatars/".$userdata['user_avatar']);
			}
		}
	}
	// Avatar Image
	$avatar = $filename !="" ? $filename : $userdata['user_avatar'];

	// Check for any other User with same Facebook ID. If not, then update his ID
	if (dbcount("(user_id)", DB_USERS, "user_fbauthid='".$_SESSION['fbc_userid']."'") == 0)
	{
		// Updating user_fbauthid
		$result = dbquery("UPDATE ".DB_USERS." SET user_avatar='".$avatar."', user_fbauthid='".$_SESSION['fbc_userid']."' WHERE user_id='".$userdata['user_id']."'");
		if (!$result)	{	$error = 1;	}
	}
	else
	{
		$error = 1;
	}

	if ($error != 0)
	{
		echo "<div class='admin-message'>".$locale['reg_err_001']."</div>";
	}
	else
	{
		echo "<div class='admin-message'>".$locale['reg_err_002']." <b>".$settings['sitename']."</b> !</div>";
	}

	echo "<table cellpadding='0' border='0' cellspacing='10' align='center'>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_002']." :</b></td>\n";
	echo "<td>".$_SESSION['fbc_username']."</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_003']." :</b></td>\n";
	echo "<td>".$_SESSION['fbc_useremail']."</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_004']." :</b></td>\n";
	echo "<td><img src='https://graph.facebook.com/".$_SESSION['fbc_userid']."/picture' alt='".$locale['reg_004']."' /></td>\n";
	echo "</tr>\n";

	echo "</table>\n";

}

if (iGUEST)
{
	if (isset($_POST['fb_register']))
	{
		$error_reg = "";
		$filename = "";
		$i = 1;

		$username = stripinput(trim(preg_replace("/ +/i", " ", $_POST['reg_user_name'])));
		$email = stripinput(trim(preg_replace("/ +/i", " ", $_SESSION['fbc_useremail'])));
		$userpassword = stripinput(trim(preg_replace("/ +/i", "", $_POST['reg_user_password'])));
		$salt = sha1($userpassword, substr($userpassword, 12));
		$password = hash_hmac('sha256', $userpassword, $salt);

		// Check If user already exists
		$name_active = dbcount("(user_id)", DB_USERS, "user_name='".$username."'");
		if ($name_active > 0)
		{
			$error_reg .= $i.". ".$locale['reg_err_003']."\n";
			$i++;
		}
		$name_inactive = dbcount("(user_code)", DB_NEW_USERS, "user_name='".$username."'");
		if ($name_inactive > 0)
		{
			$error_reg .= $i.". ".$locale['reg_err_004']."\n";
			$i++;
		}

		// Check for Blacklist
		if (dbcount("(blacklist_id)", DB_BLACKLIST, "blacklist_email='".$email."' OR blacklist_email='".substr(strrchr($email, "@"), 1)."'") != 0)
		{
			$error_reg .= $i.". ".$locale['reg_err_005']."\n";
			$i++;			
		}

		// Check if E-Mail already used
		$email_active = dbcount("(user_id)", DB_USERS, "user_email='".$email."'");
		if ($email_active > 0)
		{
			$error_reg .= $i.". ".$locale['reg_err_006']."\n";
			$i++;
		}
		$email_inactive = dbcount("(user_code)", DB_NEW_USERS, "user_email='".$email."'");
		if ($email_inactive > 0)
		{
			$error_reg .= $i.". ".$locale['reg_err_007']."\n";
			$i++;
		}

		// Check if Username is OK
		if (!preg_check("/^[-0-9A-Z_@\s]+$/i", $username))
		{
			$error_reg .= $i.". ".$locale['reg_err_008']."\n";
			$i++;
		}

		// Check if E-Mail is OK
		if (!preg_check("/^[-0-9A-Z_\.]{1,50}@([-0-9A-Z_\.]+\.){1,50}([0-9A-Z]){2,4}$/i", $email))
		{
			$error_reg .= $i.". ".$locale['reg_err_009']."\n";
			$i++;
		}

		// Check if any field is empty
		if ($username == "" || $password == "" || $email == "")
		{
			$error_reg .= $i.". ".$locale['reg_err_010']."\n";
			$i++;
		}

		// If No Errors, then Register the User and Authenticate him
		if ($error_reg == "")
		{
			// php_openssl Extension required to Read Headers from a HTTPS connection
			if (extension_loaded('openssl'))
			{
				// Uploading Facebook Avatar
				$url = "https://graph.facebook.com/".$_SESSION['fbc_userid']."/picture?type=normal";
				$location = get_headers($url, 1);
				if (array_key_exists('Location', $location))
				{
					$content = file_get_contents($location['Location']);
					if ($content)
					{
						$filename = rand().".jpg";
						while (file_exists(IMAGES."avatars/".$filename))
						{
							$filename = rand().".jpg";
						}
						$file = fopen(IMAGES."avatars/".$filename, 'w');
						fwrite($file, $content);
						fclose($file);
					}
				}
			}
			// Avatar Image
			$avatar = $filename !="" ? $filename : "";

			$result = dbquery("INSERT INTO ".DB_USERS." (user_name, user_algo, user_salt, user_password, user_email, user_avatar, user_joined, user_fbauthid) VALUES('".$username."', 'sha256', '".$salt."', '".$password."', '".$email."', '".$avatar."', '".time()."', '".$_SESSION['fbc_userid']."')");

			if (!$result)
			{
				echo "<div class='admin-message'>".$locale['reg_err_011']."</div>";
			}
			else
			{
				Authenticate::setUserCookie(mysql_insert_id(), $salt, "sha256", "", true);
				redirect(BASEDIR.$settings['opening_page']);
			}
		}
		else
		{
			echo "<div class='admin-message'>".nl2br($error_reg)."</div>";			
		}
	}

	echo "<form name='inputform' method='post' action='".FUSION_SELF."' onsubmit='return ValidateForm(this)'>";
	echo "<table cellpadding='0' border='0' cellspacing='10' align='center'>\n";

	$fb_name = isset($_POST['reg_user_name']) ? stripinput($_POST['reg_user_name']) : preg_replace("/([^0-9a-zA-Z_@\s])/", "", $_SESSION['fbc_username']);

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_005']." :</b></td>\n";
	echo "<td><input type='text' name='reg_user_name' maxlength='30' class='textbox' value='".$fb_name."' style='width:200px;' /></td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_006']." :</b></td>\n";
	echo "<td><input type='password' name='reg_user_password' maxlength='64' class='textbox' value='' style='width:200px;' autocomplete='off' /></td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_007']." :</b></td>\n";
	echo "<td><input type='password' name='reg_user_password_confirm' maxlength='64' class='textbox' value='' style='width:200px;' autocomplete='off' /></td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_003']." :</b></td>\n";
	echo "<td>".$_SESSION['fbc_useremail']."</td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_004']." :</b></td>\n";
	echo "<td><img src='https://graph.facebook.com/".$_SESSION['fbc_userid']."/picture' alt='".$locale['reg_004']."' /></td>\n";
	echo "</tr>\n";

	echo "<tr>\n";
	echo "<td><b>".$locale['reg_008']." :</b></td>\n";
	echo "<td><input type='submit' name='fb_register' value='".$locale['reg_008']."' class='button' /></td>\n";
	echo "</tr>\n";

	echo "</table>\n</form>\n";

	add_to_footer("<script type='text/javascript'>
/*<![CDATA[*/
	function ValidateForm(frm) {
		if (frm.reg_user_password.value==\"\") {
			alert(\"".$locale['reg_err_012']."\");
			return false;
		}
		if (frm.reg_user_password_confirm.value==\"\") {
			alert(\"".$locale['reg_err_013']."\");
			return false;
		}
		if (frm.reg_user_password.value != frm.reg_user_password_confirm.value) {
			alert(\"".$locale['reg_err_014']."\");
			return false;
		}
		if (frm.reg_user_name.value==\"\") {
			alert(\"".$locale['reg_err_015']."\");
			return false;
		}
		if (frm.reg_user_password.value.length < 8) {
			alert(\"".$locale['reg_err_016']."\");
			return false;
		}
	}
/*]]>*/
</script>");

}

}
else if (!isset($_SESSION['fbc_status']) || ($_SESSION['fbc_status'] == 0))
{
	if (iMEMBER)	{
		echo "<center><a href='".INFUSIONS."facebook_connect_panel/redirect.php?login=1'><img src='".INFUSIONS."facebook_connect_panel/images/fbconnect.png' alt='".$locale['panel_title']."' border='0' /></a></center>";
	}
	if (iGUEST)	{
		echo "<center><a href='".INFUSIONS."facebook_connect_panel/redirect.php?login=1'><img src='".INFUSIONS."facebook_connect_panel/images/fblogin.png' alt='".$locale['panel_title']."' border='0' /></a></center>";
	}
}

closetable();

require_once THEMES."templates/footer.php";
?>