<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright © 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: Facebook Connect Panel v1.0
| Filename: facebook_connect_panel.php
| Author: Ankur Thakur
| Version: 1.0
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/

if (file_exists(INFUSIONS."facebook_connect_panel/locale/".$settings['locale'].".php")) {
   include INFUSIONS."facebook_connect_panel/locale/".$settings['locale'].".php";
     } else {
   include INFUSIONS."facebook_connect_panel/locale/English.php"; 
}

openside($locale['panel_title']);

session_start();

if (iMEMBER)
{
	if (!isset($_SESSION['fbc_status']) || ($_SESSION['fbc_status'] == 0))
	{
		echo "<center><a href='".INFUSIONS."facebook_connect_panel/redirect.php?login=1'><img src='".INFUSIONS."facebook_connect_panel/images/fbconnect.png' alt='".$locale['panel_title']."' border='0' /></a></center>";
	}
	else if (isset($_SESSION['fbc_status']) && ($_SESSION['fbc_status'] == 1))
	{
		echo "<center>\n<img src='https://graph.facebook.com/".$_SESSION['fbc_userid']."/picture?type=normal' alt='".$locale['reg_004']."' /><br /><br />\n";
		echo "<a href='".INFUSIONS."facebook_connect_panel/redirect.php?logout=1'><img src='".INFUSIONS."facebook_connect_panel/images/fblogout.png' alt='".$locale['inf_title']."' border='0' /></a>\n</center>\n";

		if (!$userdata['user_fbauthid'])
		{
			if (FUSION_SELF != 'register.php') {
			redirect(BASEDIR."infusions/facebook_connect_panel/register.php");
			}
		}
	}
}
if (iGUEST)
{
	if (!isset($_SESSION['fbc_status']) || ($_SESSION['fbc_status'] == 0))
	{
		echo "<center><a href='".INFUSIONS."facebook_connect_panel/redirect.php?login=1'><img src='".INFUSIONS."facebook_connect_panel/images/fblogin.png' alt='".$locale['panel_title']."' border='0' /></a></center>";
	}
	else if (isset($_SESSION['fbc_status']) && ($_SESSION['fbc_status'] == 1))
	{
		echo "<center>\n<img src='https://graph.facebook.com/".$_SESSION['fbc_userid']."/picture?type=normal' /><br /><br />\n";
		echo "<a href='".INFUSIONS."facebook_connect_panel/redirect.php?logout=1'><img src='".INFUSIONS."facebook_connect_panel/images/fblogout.png' alt='".$locale['inf_title']."' border='0' /></a>\n</center>\n";

		// This condition is to prevent Circular Redirection in case Facebook gets Down and don't provide any User ID
		if (($_SESSION['fbc_userid'] != 0) && ($_SESSION['fbc_userid'] != ""))
		{
		$checkuser = dbquery("SELECT user_id, user_salt, user_algo FROM ".DB_USERS." WHERE user_fbauthid='".$_SESSION['fbc_userid']."' AND user_status='0' AND user_actiontime='0' LIMIT 1");

		if (dbrows($checkuser) == 1)
		{
			$user = dbarray($checkuser);
			Authenticate::setUserCookie($user['user_id'], $user['user_salt'], "sha256", "", true);
			redirect(BASEDIR.$settings['opening_page']);
		}
		else if (dbrows($checkuser) == 0)
		{
			if (FUSION_SELF != 'register.php') {
			redirect(BASEDIR."infusions/facebook_connect_panel/register.php");
			}
		}

		}
	}
}

closeside();
?>