<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Infusion: Facebook Connect Panel v1.0
| Filename: infusion.php
| Author: Ankur Thakur, Nick Jones
| Version: 1.0
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

include INFUSIONS."facebook_connect_panel/infusion_db.php";

if (file_exists(INFUSIONS."facebook_connect_panel/locale/".$settings['locale'].".php")) {
	include INFUSIONS."facebook_connect_panel/locale/".$settings['locale'].".php";
} else {
	include INFUSIONS."facebook_connect_panel/locale/English.php";
}

// Infusion general information
$inf_title = $locale['inf_title'];
$inf_description = $locale['inf_description'];
$inf_version = "1.0";
$inf_developer = "Ankur Thakur";
$inf_email = "thakurboyz2007@gmail.com";
$inf_weburl = "http://ankurthakur.in/";

$inf_folder = "facebook_connect_panel";

$inf_adminpanel[1] = array(
	"title" => $locale['inf_title'],
	"image" => "fcp.png",
	"panel" => "facebook_connect_panel_admin.php",
	"rights" => "FCP"
);

?>