<?php
/*-------------------------------------------------------+
| Infusion: Facebook Connect Panel v1.0
| Author: Ankur Thakur
| Version: 1.0
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------*/

// Infusion Details
$locale['inf_title'] = "Facebook Connect Panel";
$locale['inf_description'] = "Facebook Connect Panel makes your Website Visitors easily Register using their Facebook Account in few seconds. It also allows your Members to Log In using their Facebook Account in 1-Click Log-In..";

// Panel
$locale['panel_title'] = "Connect via Facebook";

// Register
$locale['reg_err_001'] = "Failed to Update your Information !";
$locale['reg_err_002'] = "Successfully Connected your Facebook Account to";
$locale['reg_err_003'] = "A User with the same Username as you have already exists.";
$locale['reg_err_004'] = "A User with the same Username as you have already waiting for Registration Confirmation.";
$locale['reg_err_005'] = "Sorry. But you are Blacklisted.";
$locale['reg_err_006'] = "A User with the same E-Mail Address as you have already exists.";
$locale['reg_err_007'] = "A User with the same E-Mail Address as you have already waiting for Registration Confirmation.";
$locale['reg_err_008'] = "Bad Characters used in the Username.";
$locale['reg_err_009'] = "Bad Characters used in the E-Mail Address.";
$locale['reg_err_010'] = "Some fields are Left blank. Please fill them.";
$locale['reg_err_011'] = "Failed to Register.";
$locale['reg_err_012'] = "Password can not be left empty.";
$locale['reg_err_013'] = "Confirm Password can not be left empty.";
$locale['reg_err_014'] = "Password doesnt match.";
$locale['reg_err_015'] = "User Name can not be left empty.";
$locale['reg_err_016'] = "Password must be of atleast 8 characters.";
$locale['reg_001'] = "Connect via Facebook";
$locale['reg_002'] = "Facebook Name";
$locale['reg_003'] = "E-Mail Address";
$locale['reg_004'] = "Profile Picture";
$locale['reg_005'] = "User Name";
$locale['reg_006'] = "Password";
$locale['reg_007'] = "Confirm Password";
$locale['reg_008'] = "Register";

// Admin Panel
$locale['admin_title'] = "Facebook Connect Panel Users Tracking";
$locale['admin_install'] = "Facebook Connect Panel Installation";
$locale['admin_warning'] = "Do not forget to Edit <b>infusions/facebook_connect_panel/includes/config.php</b> in your Server.";
$locale['admin_install_btn'] = "Install";
$locale['admin_uninstall_btn'] = "Un-Install";
$locale['action_install'] = "Facebook Connect Panel Installed successfully.";
$locale['action_uninstall'] = "Facebook Connect Panel Un-Installed successfully.";
$locale['action_unlink'] = "User Facebook Account Un-Linked successfully.";
$locale['uninstall_confirm'] = "All Facebook Connected Users will not be able to Log-In using Facebook. Do you really want to Un-Install ?";
$locale['unlink_confirm'] = "Do you really want to Un-Link this Users Facebook Account from website ?";
$locale['not_installed'] = "Not Installed. Click button below to Install.";
$locale['yes_installed'] = "Facebook Connect Panel Installed. Click button below to Un-Install.";
$locale['fpc_admin_001'] = "User ID";
$locale['fpc_admin_002'] = "Facebook ID";
$locale['fpc_admin_003'] = "Un-Link";
$locale['fpc_panel_001'] = "Facebook Connect Panel";
$locale['fpc_panel_002'] = "in Panels";
$locale['fpc_panel_003'] = "Facebook Connect Debugging Panel";
$locale['fpc_panel_en'] = "Enabled";
$locale['fpc_panel_ds'] = "Disabled";

// Copyright
$locale['cr_author'] = "<a href='http://ankurthakur.in/' target='_blank'>Facebook Connect Panel v1.0 - By Ankur Thakur</a>";
$locale['update_001'] = " Version ";
$locale['update_002'] = " is available to Download. Click here to Download.";
?>