<?php
/*-------------------------------------------------------+
| Infusion: Facebook Connect Panel v1.0
| Author: Ankur Thakur
| Version: 1.0
| Developers: Ankur Thakur
|             http://ankurthakur.in/
+--------------------------------------------------------*/

// Infusion Details
$locale['inf_title'] = "Integracja z Facebookiem";
$locale['inf_description'] = "Panel integracji z Facebookiem pozwala gościom Twojej strony łatwo rejestrować się na niej używając konta z Facebooka w kilka sekund. Pozwala także na logowanie się Użytkowników używając Facebookowego kona jednym kliknięciem!";

// Panel
$locale['panel_title'] = "Integruj się z Facebookiem";

// Register
$locale['reg_err_001'] = "Błąd podczas pobierania danych!";
$locale['reg_err_002'] = "Pomyślnie połączono konto z Facebookiem na stronie ";
$locale['reg_err_003'] = "Użytkownik z taką nazwą już istnieje.";
$locale['reg_err_004'] = "Użytkownik o takiej nazwie użytkownika czeka na potwierdzenie rejestracji.";
$locale['reg_err_005'] = "Przepraszamy, jesteś zbanowany.";
$locale['reg_err_006'] = "Użytkownik z takim E-Mailem już istnieje!.";
$locale['reg_err_007'] = "Użytkownik z takim E-Mailem czeka na potwierdzenie rejestracji.";
$locale['reg_err_008'] = "Złe znaki w nazwie użytkownika.";
$locale['reg_err_009'] = "Złe znaki w adresie E-Mail.";
$locale['reg_err_010'] = "Niektóre pola są pustę. Proszę, uzupełnij je.";
$locale['reg_err_011'] = "Wystąpił błąd podczas rejestracji.";
$locale['reg_err_012'] = "Pole z hasłem nie może być puste!.";
$locale['reg_err_013'] = "Pole z potwierdzeniem hasła nie może być puste!.";
$locale['reg_err_014'] = "Hasło nie pasuje.";
$locale['reg_err_015'] = "Pole z nazwą użytkownika nie może być puste.";
$locale['reg_err_016'] = "Hasło musi zawierać minimum 8 znaków.";
$locale['reg_001'] = "Połącz się z Facebookiem";
$locale['reg_002'] = "Nazwa z Facebooka";
$locale['reg_003'] = "Adres E-Mail";
$locale['reg_004'] = "Zdjęcie profilowe";
$locale['reg_005'] = "Nazwa Użytkownika";
$locale['reg_006'] = "Hasło";
$locale['reg_007'] = "Potwierdzenie hasła";
$locale['reg_008'] = "Rejestracja";

// Admin Panel
$locale['admin_title'] = "Użytkownicy korzystający z integracji z Facebookiem";
$locale['admin_install'] = "Integracja z Facebookiem - instalacja";
$locale['admin_warning'] = "Nie zapomnij edytować pliku <b>infusions/facebook_connect_panel/includes/config.php</b> na Twoim serwerze!";
$locale['admin_install_btn'] = "Instaluj";
$locale['admin_uninstall_btn'] = "Odinstaluj";
$locale['action_install'] = "Instalacja panelu integracji z Facebookiem zakończona pomyślnie.";
$locale['action_uninstall'] = "Odinstalowanie panelu integracji z Facebookiem zakończono pomyślnie.";
$locale['action_unlink'] = "Odłączenie konta użytkownica z Facebookiem zakończona pomyślnie.";
$locale['uninstall_confirm'] = "Wszyscy użytkownicy korzystający z integracji nie będą mogli się zalogować używając Facebooka. Czy na pewno chcesz odinstalować?";
$locale['unlink_confirm'] = "Jesteś pewien, że chcesz odłączyć integracje konta tego użytkownika z Facebookiem?";
$locale['not_installed'] = "Nie zainstalowany. Kliknij przycisk poniżej, aby zainstalować..";
$locale['yes_installed'] = "Panel intergracji z Facebookiem zainstalowany. Kliknij przycisk poniżej, by go odinstalować.";
$locale['fpc_admin_001'] = "ID użytkownika";
$locale['fpc_admin_002'] = "ID Facebooka";
$locale['fpc_admin_003'] = "Odłącz";
$locale['fpc_panel_001'] = "Panel integracji z Facebookiem";
$locale['fpc_panel_002'] = "w Panelach";
$locale['fpc_panel_003'] = "Panel debugowanie integracji z Facebookiem";
$locale['fpc_panel_en'] = "Odblokowany";
$locale['fpc_panel_ds'] = "Zablokowany";

// Copyright
$locale['cr_author'] = "<a href='http://ankurthakur.in/' target='_blank'>Facebook Connect Panel v1.0 - By Ankur Thakur</a>";
$locale['update_001'] = " Wersja ";
$locale['update_002'] = " jest możliwa do ściągnięcia. Kliknij tutaj, by ją pobrać.";
?>